from flask import Flask
from config import Config
from redis import Redis
import rq

app = Flask(__name__)
app.config.from_object(Config)

app.redis = Redis.from_url(app.config['REDIS_URL'])
app.task_queue = rq.Queue('baangt-tasks', connection=app.redis, default_timeout=app.config['REDIS_TASK_TIMEOUT'])

from app import api, models
