from baangt.base.TestRun.TestRun import TestRun
from . import app
#from flask import current_app
import requests
import os
import json

app.app_context().push()

def run_testrun(testRunName, globalSettings, testRunDict, testRunId):
	#
	# Testrun execution task
	#

	# get DataFiles
	if testRunDict:
		for key, value in testRunDict['GC.KWARGS_TESTRUNATTRIBUTES']['GC.STRUCTURE_TESTCASESEQUENCE'].items():
			dataFileId = value[1]['GC.DATABASE_FILENAME']
			url = '/'.join((
				'http:/',
				app.config.get('BAANGT_DATAFILE_HOST'),
				app.config.get('BAANGT_DATAFILE_GET'),
				dataFileId,
			))
		
			r = requests.get(url, stream=True)
			if r.status_code == 200:
				with open(os.path.join(os.path.abspath(os.path.dirname(__file__)), app.config['UPLOAD_FOLDER'], dataFileId), 'wb') as f:
					for chunck in r:
						f.write(chunck)
			else:
				raise Exception(f'Data File ID {dataFileId} does not exist.')

	# set path to globals
	if globalSettings:
		# custom globals
		path_to_globals = os.path.join(os.path.abspath(os.path.dirname(__file__)), app.config['UPLOAD_FOLDER'], 'custom_globals.json')
		# set browser headless mode
		if globalSettings.get('TC.BrowserAttributes'):
			globalSettings['TC.BrowserAttributes']['HEADLESS'] = 'True'
		else:
			globalSettings['TC.BrowserAttributes'] = {'HEADLESS': 'True'}
		# dump globals to file
		with open(path_to_globals, 'w') as f:
			json.dump(globalSettings, f)
	else:
		# default globals
		path_to_globals = os.path.join(os.path.abspath(os.path.dirname(__file__)), app.config['UPLOAD_FOLDER'], 'globals.json')

	tr = TestRun(
		testRunName=testRunName,
		globalSettingsFileNameAndPath=path_to_globals,
		testRunDict=testRunDict,
		uuid=testRunId,
		noCloneXls=True,
	)

	# upload files to file-service: logfile, results
	# get files	
	logfile = open(tr.results.logfile, 'rb')
	outfile = open(tr.results.fileName, 'rb')

	# upload
	url = '/'.join((
		'http:/',
		app.config.get('BAANGT_DATAFILE_HOST'),
		app.config.get('BAANGT_DATAFILE_UPLOAD'),
		str(testRunId),
	))	
	r = requests.post(url, files={'logfile': logfile, 'outfile': outfile})
	
	# close files
	logfile.close()
	outfile.close()

	if r.status_code != 200:
		raise Exception(f'Failed upload result files: {r.status_code} - {r.text}')


