import os


#
# configuration settings
#

class Config(object):
	# flask secret key
	SECRET_KEY = os.getenv('SECRET_KEY') or 'secret!key'

	# json format
	JSON_SORT_KEYS = False

	# upload files
	UPLOAD_FOLDER = 'uploads'
	ALLOWED_EXTENSIONS = {'XLSX', 'JSON'}

	#
	# baangt DataFile service
	#
	BAANGT_DATAFILE_HOST = os.getenv('BAANGT_DATAFILE_HOST') or '127.0.0.1:5050'
	BAANGT_DATAFILE_GET = 'get'
	BAANGT_DATAFILE_UPLOAD = 'upload'

	# REDIS
	REDIS_URL = os.environ.get('REDIS_URL') or 'redis://'
	REDIS_TASK_TIMEOUT = 600

	# API URL
	API_BASE = 'v0.1'

	
