from flask_wtf import FlaskForm
from wtforms.fields import FileField
from wtforms.validators import ValidationError, DataRequired
import app

class UploadForm(FlaskForm):
	file = FileField('Select Data File', validators=[DataRequired(message='Data File is mandatory')])

	def validate_extension(self, file):
		if '.' in file.filename and file.filename.split('.')[-1].upper() in app.config.get('ALLOWED_EXTENSIONS'):
			return
		raise ValidationError('Only XLSX files allowed')