from lxml import html
from random import randrange
import os# import path, remove

# path to data
path_to_data = os.path.join(os.path.abspath(os.path.dirname(__file__)), 'data')

'''
item_data = {
    'name': 'Test Item Name',
    'description': 'Test Item Description',
}

# supplementary
def dump_html(r):
    #
    # dumps response data to test.html
    #

    with open('test.html', 'w') as f:
        f.write(r.data.decode())

#
# support functions 
#
def login(client, user):
    #
    # login to web system
    #
  
    # login
    r = client.post('/login', data={
        'csrf_token': get_csrf(client, '/login'),
        'username': user.get('username'),
        'password': user.get('password'),
    })

def logout(client):
    #
    # logout web system
    #

    client.get('/logout')

def get_csrf(client, url):
    #
    # get csrf_token for $url page
    #

    r = client.get(url)
    page = html.fromstring(r.data)

    return page.xpath('//input[@id="csrf_token"]')[0].value

def generate_password(length=7):
    return ''.join([chr(randrange(33, 127)) for i in range(length)])

def remove_file(path_to_file):
    try:
        os.remove(path_to_file)
    except:
        raise Exception(f'Test file does not exist: {path_to_file}')

def get_datafile_url(config, datafile_id):
    return '/'.join((
        'http:/',
        config.get('BAANGT_DATAFILE_HOST'),
        config.get('BAANGT_DATAFILE_GET'),
        datafile_id,
    ))


class TRTestHelper:
    TCS = 0
    TC = 1
    TSS = 2
    TS = 3

    def __init__(self, testrun):
        self.tr = testrun

    def get_num(self, layer):
        #
        # returns number of all abjects on the layer 
        #

        if layer == self.TCS:
            return len(self.tr.testcase_sequences)

        counter = 0
        # TestCaseSequence
        for tcs in self.tr.testcase_sequences:
            # TestCase
            for tc in tcs.testcases:
                if layer == self.TC:
                    counter += 1
                else:
                    # TestStep
                    for tss in tc.teststep_sequences:
                        if layer == self.TSS:
                            counter += 1
                        else:
                            # TestStepExecution
                            for ts in tss.teststeps:
                                counter += 1
        return counter

    def get_indexes(self, layer):
        #
        # returns tuple of indexes and layer 
        #

        # child indexes
        tc_index, tss_index, ts_index = 0, 0, 0

        # TestCaseSequence
        for tcs_index, tcs in enumerate(self.tr.testcase_sequences, 1):
            if layer == self.TCS:
                yield tcs_index, tcs
            else:
                # TestCase
                for tc in tcs.testcases:
                    tc_index += 1
                    if layer == self.TC:
                        yield tcs_index, tc_index, tc
                    else:
                        # TestStep
                        for tss in tc.teststep_sequences:
                            tss_index += 1
                            if layer == self.TSS:
                                yield tcs_index, tc_index, tss_index, tss
                            else: 
                                # TestStepExecution
                                for ts in tss.teststeps:
                                    ts_index += 1
                                    yield tcs_index, tc_index, tss_index, ts_index, ts
'''
