#!/bin/bash

# default mysql port
port="3305"

# parse arguments
args=("$@")

if [ $# -gt 0 ]
then
	port=${args[0]}
fi

echo ${args}
echo $#
echo Port: ${port}

# building docker images
echo
echo Building MySQL image...
docker build -t mysql-baangt:latest mysql

# running docker container
echo
echo Starting MySQL container...
docker run --name mysql -p ${port}:3306 -d -e MYSQL_RANDOM_ROOT_PASSWORD=yes --rm mysql-baangt:latest
