document.addEventListener('DOMContentLoaded', () => {

    // filters
    document.querySelectorAll('select').forEach(select => {
        select.onchange = () => {
            // get name
            const tr_id = document.querySelector('#selectName').value;
            //const name = document.querySelector('#selectName').children[name_index].text;
            // get stage
            const stage_index = document.querySelector('#selectStage').value;
            const stage = document.querySelector('#selectStage').children[stage_index].text;
            // apply filters
            document.querySelectorAll('.hovered-item').forEach(item => {
                if ((tr_id == "0" || item.dataset['id'] == tr_id) && (stage_index == "0" || item.dataset['stage'] == stage)) {
                    item.style.display = '';
                } else {
                    item.style.display = 'none';
                }
            });
        };
    });
    
    // testruns-stages items
    document.querySelectorAll('.hovered-item').forEach(item => {
        // get chart data
        const request = new XMLHttpRequest();
        request.responseType = 'json';
        request.open('POST', `/chart/${item.dataset['id']}/${item.dataset['stage']}`);
        request.onload = () => {
            // set figures
            const figures = request.response['figures'];
            // records
            item.querySelector('.records').querySelector('h2').innerHTML = figures['records'];
            // successfull
            if (figures['successful'] > 0) {
                item.querySelector('.passed').querySelector('h2').innerHTML = figures['successful'];
            } else {
                 item.querySelector('.passed').setAttribute('class', 'hide');
            }
            // errors
            if (figures['error'] > 0) {
                item.querySelector('.failed').querySelector('h2').innerHTML = figures['error'];
            } else {
                 item.querySelector('.failed').setAttribute('class', 'hide');
            }
            // paused
            if (figures['paused'] > 0) {
                item.querySelector('.paused').querySelector('h2').innerHTML = figures['paused'];
            } else {
                item.querySelector('.paused').setAttribute('class', 'hide');
            }
            // customize legend
            var duration = request.response['duration'];
            duration['options']['tooltips']['callbacks'] = {
                label: function(item, data) {
                    var label = data.datasets[item.datasetIndex].label || '';
                    if (label) {
                        label += ': ';
                    }
                    label += item.value;
                    label += ' sec';

                    return label;
                }
            };
            // draw charts 
            var statusChart = new Chart(item.querySelector('.statusChart'), request.response['status']);
            var resultsChart = new Chart(item.querySelector('.resultsChart'), request.response['results']);
            var durationChart = new Chart(item.querySelector('.durationChart'), duration);

            // hide loading screen
            document.querySelector('#loading-active').style.display = 'none';
        };
        request.send();
    });
});