document.addEventListener('DOMContentLoaded', () => {
    // get chart data
    const call_id = document.querySelector('main').id;
    const request = new XMLHttpRequest();
    request.responseType = 'json';
    request.open('POST', `/summary/${call_id}`);
    request.onload = () => {
        // set figures
        const figures = request.response['figures'];
        // records
        document.querySelector('#records').querySelector('div').innerHTML = figures['records'];
        // successfull
        if (figures['successful'] > 0) {
            document.querySelector('#passed').querySelector('div').innerHTML = figures['successful'];
        } else {
            document.querySelector('#passed').setAttribute('class', 'hide');
        }
        // errors
        if (figures['error'] > 0) {
            document.querySelector('#failed').querySelector('div').innerHTML = figures['error'];
        } else {
            document.querySelector('#failed').setAttribute('class', 'hide');
        }
        // paused
        if (figures['paused'] > 0) {
            document.querySelector('#paused').querySelector('div').innerHTML = figures['paused'];
        } else {
            document.querySelector('#paused').setAttribute('class', 'hide');
        }
        // customize legend
        /*
        var duration = request.response['duration'];
        duration['options']['tooltips']['callbacks'] = {
            label: function(item, data) {
                var label = data.datasets[item.datasetIndex].label || '';
                if (label) {
                    label += ': ';
                }
                label += item.value;
                label += ' sec';

                return label;
            }
        };
        */
        // draw status chart 
        var statusChart = new Chart(document.querySelector('#statusChart'), request.response['status']);
        // draw testcase charts
        const testcases = document.querySelector('#testcaseCharts');
        request.response['testcases'].forEach(testcase => {
            var canvas = document.createElement('canvas');
            canvas.setAttribute('class', 'rounded border w-100 mb-4 p-2 shadow');
            var chart = new Chart(canvas, testcase);
            testcases.appendChild(canvas);
        });

        // add files
        console.log('Files');
        const files = document.querySelector('#fileList');
        request.response['files'].forEach(file => {
            var file_item = document.createElement('li');
            file_item.setAttribute('class', 'list-group-item');
            file_item.innerHTML = `
                <div class="row">
                    <div class="col-2 h5">
                        ${file['title']}
                    </div>
                    <div class="col-10 h6">
                        <a href="${file['url']}">${file['url']}</a>
                    </div>
                </div>
            `;
            files.appendChild(file_item);
        });

        // hide loading screen
        document.querySelector('#loading-active').style.display = 'none';

    };
    request.send();

});