from app import app
from flask_login import current_user
from flask import flash
import requests
import json


def uploadDataFile(file, file_id=None):
    #
    # uploads DataFile to file-service
    #

    # call DataFile Service
    if file_id:
        # update
        url = '/'.join((
            'http:/',
            app.config.get('BAANGT_DATAFILE_HOST'),
            app.config.get('BAANGT_DATAFILE_UPDATE'),
            file_id,
        ))
    else:
        # create
        url = '/'.join((
            'http:/',
            app.config.get('BAANGT_DATAFILE_HOST'),
            app.config.get('BAANGT_DATAFILE_SAVE'),
        ))
    app.logger.info(f'Call {url} to save file {file.filename} by {current_user}.')

    try:
        r = requests.post(url, files={'dataFile': file})

        if r.status_code == 200:
            response = json.loads(r.text)
            app.logger.info(f'Uploaded DataFile {response.get("uuid")} by {current_user}')
            return response.get('uuid')
        else:
            app.logger.warning(f'Faild upload DataFile {file.filename} by {current_user}: {r.status_code} {r.text}')
            flash(f'WARNING: Faild upload DataFile {file.filename}: {r.status_code} {r.text}', 'warning')
            return None
    except Exception as e:
        app.logger.warning(f'Faild upload DataFile {file.filename} by {current_user}: {e}')
        flash(f'WARNING: Faild upload DataFile {file.filename}: {e}', 'warning')
        return None
