import os


#
# configuration settings
#

class Config(object):
	#
	# secret 
	#
	SECRET_KEY = os.getenv('SECRET_KEY') or 'secret!key'

	#
	# SQL Alchemy
	#
	SQLALCHEMY_DATABASE_URI = os.getenv('DATABASE_URL') or \
		'sqlite:///' + os.path.join(os.path.abspath(os.path.dirname(__file__)), 'testrun.db')
	SQLALCHEMY_TRACK_MODIFICATIONS = False

	#
	# baangt API web-service
	#
	BAANGT_API_HOST = os.getenv('BAANGT_API_HOST') or '127.0.0.1:8000'
	BAANGT_API_EXECUTE = 'v0.1/run/json'
	BAANGT_API_STATUS = 'v0.1/results/json'

	#
	# baangt DataFile service
	#
	BAANGT_DATAFILE_HOST = os.getenv('BAANGT_DATAFILE_HOST') or '127.0.0.1:5050'
	BAANGT_DATAFILE_SAVE = 'save'
	BAANGT_DATAFILE_UPDATE = 'update'
	BAANGT_DATAFILE_GET = 'get'
	BAANGT_DATAFILE_LOGFILE = 'logfile'
	BAANGT_DATAFILE_RESULTS = 'outfile'

	#
	# baangt testrun settings
	#
	BAANGT_TESTRUN_GLOBALS_DEFAULT = 'app/static/json/globals.json'


	
