from tests.supports import login, path_to_data
from lxml import html
import json
import os

def test_docs_urls(client, test_user):
    url = '/docs/'

    # unauthorized access
    r = client.get(url, follow_redirects=True)
    assert r.status_code == 200

    # unauthorized access
    login(client, test_user)
    r = client.get(url, follow_redirects=True)
    assert r.status_code == 200

    # assert links to doc chapters
    with open(os.path.join(path_to_data, 'doc_chapters.json'), 'r') as f:
        chapters = json.load(f)
    page = html.fromstring(r.data)
    chapter_div = page.xpath(f'//main/div')
    assert bool(chapter_div)
    chapter_links = chapter_div[0].xpath('./a')
    assert len(chapter_links) == len(chapters)
    for index, link in enumerate(chapter_links):
        href = link.attrib.get('href')
        assert href.split('/')[-1] in chapters, f'Link {index} is NOT in chapter list'
        r = client.get(href)
        assert r.status_code == 200, f'Accessing "{href}". Status code: {r.status_code}'

